package org.apache.bcel.generic;

import org.apache.bcel.util.ByteSequence;
import java.io.IOException;
import java.io.DataOutputStream;

public class GOTO_W extends GotoInstruction
{
    GOTO_W() {
    }
    
    public GOTO_W(final InstructionHandle target) {
        super((short)200, target);
        super.setLength(5);
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitUnconditionalBranch(this);
        v.visitBranchInstruction(this);
        v.visitGotoInstruction(this);
        v.visitGOTO_W(this);
    }
    
    @Override
    public void dump(final DataOutputStream out) throws IOException {
        super.setIndex(this.getTargetOffset());
        out.writeByte(super.getOpcode());
        out.writeInt(super.getIndex());
    }
    
    @Override
    protected void initFromFile(final ByteSequence bytes, final boolean wide) throws IOException {
        super.setIndex(bytes.readInt());
        super.setLength(5);
    }
}
